//TC func

void delay(unsigned int i)                      //every tick is 5.3 Usec
  {
   do
    {
    i--;
    WDTCTL = WDTPW + WDTCNTCL;                  //Periodically clear an active watchdog
    }
    while (i != 0);
      _NOP();
   }

//this function is testing the batt by charging the BATT_TST cap in 0.25 VCC and
// compering it to the internal 0.55v VREFthe
//it returnes 1 if $$$
//and 0 if $$$
//  change batt test to use the resistores and the timer

unsigned int Batt_Check(void)
    {
    CACTL1 = CARSEL + CAREF_2 + CAREF_1 + CAON; // set internal 0.55V ref on comp in -,comp module is on
    CACTL2 = P2CA0;                             // P2.3 = +comp

    P2OUT |= BATT_TST_PWR;                      //open batt test voltage
    delay(4000);

    i=(CACTL2 & CAOUT);                         // test the voltage
    P2OUT &= ~BATT_TST_PWR;                     // close test voltage
    CACTL1 = 0x00;                              // Disable Comp_A, save power
    CACTL2 = 0x00;                              // disable comp input

    return i;
    }


void init(void)
    {
    CCTL0 = CCIE;                                   // CCR0 interrupt enabled
    CCR0 = TIMER_INTERVAL;
    TACTL = TASSEL_1 + MC_1;                        // ACLK, upmode

    //P2OUT &= ~MAC_SW_PWR;                           //close mac sw power
    //P1OUT &= ~MOTOR;                                //close motor
    //P2OUT |= GREEN_LED;                             //close leds
    //P1OUT |= ORANGE_LED;                            //close leds

    P1DIR |= MOTOR + ORANGE_LED + TP8;               // Set P1.0, P1.2 to output direction
    
    P2DIR |= GREEN_LED + MAC_SW_PWR + BATT_TST_PWR + TP7 ;  // Set p2.0 p2.1, P2.2 p2.5 to output direction

    P1IES |= ON_SW;                                 // Interrupt on Falling Edge
    _BIS_SR( GIE);                                  // enable interrupt
   }	




void CalcChecksum(void *Start, unsigned int len,void *cs_add)
    {
    unsigned long Sum = 0;                  //the calculation reg
    unsigned int *pStart = Start;           //programm read pointer
    unsigned int *CS_add = cs_add;          //cs read pointer

    while (len)                             // sum all the memory words
        {
        Sum = Sum + *pStart++;
        len = len - 2;
        WDTCTL = WDTPW + WDTCNTCL;              //Periodically clear an active watchdog
        }

    saved_cs=*CS_add;
    calc_cs=(unsigned int)Sum;

    if( saved_cs != calc_cs )
       {
#ifdef ENABLE_CHECK_SUM
        while(1)
            WDTCTL = WDTPW + WDTCNTCL;                              //Periodically clear an active watchdog

#endif
       }
    }





#pragma vector=TIMERA0_VECTOR               // Timer A0 interrupt service routine gives a "tick" every 100mS
__interrupt void Timer_A (void)
    {
    tick=1;                                 //set tick to indicate timer overflw
    P1OUT ^= TP8;                           //togle TP8 every 100 Ms
    }

#pragma vector=PORT1_VECTOR                 // port 1 interrupt service routine
__interrupt void Port1 (void)               //dumi jump to the sw int so micro will wake up
    {
     __low_power_mode_off_on_exit();
    P1IE  &= ~ON_SW;                        //disable ONOFF SW int
    P1IFG &= ~ON_SW;                        //reset flag
    }

