//*******************************************************************************
//  MSP-FET430x110 TC for Flow Medic
//
//  Michael Alon
//
//  v1.20  11.3.05    ver for new pcb and new MMI working ok
//  v1.25  11.3.05    working ok vbat low is 2.2v on external cap
//  v1.30  12.3.05    working ok vbat low is 2.4v with external resistores
//  v1.48  12.4.05    Mark trying to get the MAC_SW to switch off TC when closed
//                    To find what I have changed Look for // Mark changed here v1.48
//  v1.49  12.4.05    MAC_SW returned to Normally Open
//  v1.50  12.4.05    Timing problem fixed
//                    To find what I have changed Look for //make sys run faster in test mode TP5 is at gnd
//  V1.51  13.4.05    On/Off Switch problem fixed
//  v1.60  13.4.05    wdt and checksum added new low batt machanisem and sw diet
//                      project splite to 3 files
//  v1.61  13.4.05    leds low curent test
//  v1.62  16.4.05    ready for FDA test with mike ,leds power can be adjusted
//  v1.63  16.4.05    WDT machanisem changed and debaunce added to MAC SW on  run mode
//  new ver
//  v1.0.7  18.4.05    sys will rstart on wdt reset
//  v1.0.8  18.4.05    like  v1.0.7  80 sec time changed
//  v1.0.9  18.4.05    new WDT machanisem added
//  v1.0.10  18.4.05   new low batt with timers added
//  v1.0.11  18.4.05   ext resistor added for temp stabilty
//  v1.0.12  15.5.05   new sw orgenazation for low batt machanisem
//  v1.0.13  15.5.05   rc times calibrated
//  v1.0.14  18.5.05   rc times calibrated
//  v1.0.15  13.7.05   changed Low Batt Low time from 78s to 74s

//  v1.0.19  16.12.05  new mmechanisem for new pcb and sw
//  v1.0.20  27.12.05  minimum sw press added and max time reduced to 12
//  v1.0.21  28.12.05  fixing bugs in minimum sw press added and max time reduced to 12
//  v1.1.0  30.12.05  sw pased the validation with mike and its name changed to v1.1.0

//******************************************************************************
//  to do


#define ENABLE_CHECK_SUM
//#define	EXT_RESISTOR

const int saved_CS @ 0xfffc =  0x0886; //0x4cf8; //0x4cd0; //0x4d48;                          //this is the address that the CS is saved in !!!only good for the 1011A

#include  <msp430x11x1.h>
#include "TC.h"
#include "TC func.c"
#include "process handler.c"


void main(void)
    {
#ifdef EXT_RESISTOR
    BCSCTL2 |= DCOR + DIVS_1;             // use ext Rosc and divide in 2
    _BIS_SR(OSCOFF);                      // XTAL not used
#endif

    WDTCTL = WDTPW + WDTCNTCL;                              //Periodically clear an active watchdog

    init();                                                 //init uC

    CalcChecksum((unsigned char *)ROM_START, ROM_END - ROM_START,(unsigned char *)&saved_CS);


    if(! Batt_Check() )		                    //test for low batt on startup
        stat=LOW_BATT;      		                    //if low batt change sys statuse
    else if(IFG1 &  WDTIFG )                                //check if we wake up from int and if so change stat to run mode
        stat=RUN;
    else
        stat=SLEEP;


    while(1)
        {
        WDTCTL = WDTPW + WDTCNTCL;                              //Periodically clear an active watchdog
        switch(stat)
            {
            case LOW_BATT:  process_low_batt();
                            break;

            case RUN:       process_run();
                            break;

            case SLEEP:     process_sleep();
                            break;
            }     
        }
    }







