void process_low_batt()                                     //LOW BATT function
    {
    P1OUT &= ~MOTOR+ORANGE_LED;			                    //close motor open orange led
    P2OUT &= ~ MAC_SW_PWR;	 	                            //close mac sw power
    P2OUT |= GREEN_LED;	 	                                //and green led

    off_tmr=0;

    while(!(P1IN & ON_SW))                                 //wait for ON_SW relese
        WDTCTL = WDTPW + WDTCNTCL;                          //Periodically clear an active watchdog

    while(stat==LOW_BATT)
        {
        WDTCTL = WDTPW + WDTCNTCL;                          //Periodically clear an active watchdog

        if(tick)                                            //if timer tick
            {
            tick=0;

            if(!(P1IN & ON_SW))                             //a 200 Ms debaunce for sw press
                {								
                if(on_sw_cntr++ > ON_SW_DEBAUNCE)
                    stat=SLEEP;
                 }
            else
                on_sw_cntr=0;

            if(++off_tmr > LOW_BATT_OFF_TIME)
                     stat=SLEEP;
            }
        }
    }


void process_sleep()
    {
    while(stat==SLEEP)
        {
        P1OUT &= ~(ORANGE_LED + MOTOR + TP8);
        P1OUT |= ORANGE_LED;

        P2OUT &= ~(BATT_TST_PWR + GREEN_LED + MAC_SW_PWR + TP7);
        P2OUT |= GREEN_LED;

        P1DIR |= ORANGE_LED + MOTOR + TP8;                      // Set P1.0, P1.2 to output direction
        P2DIR |= BATT_TST_PWR + GREEN_LED + MAC_SW_PWR +  TP7 ; // Set p2.0 p2.1, P2.2 p2.5 to output direction

        P1IFG &= ~ON_SW;                                        // ON_SW IFG cleared
        P1IE  |= ON_SW;                                         //enable ONOFF SW int to wake up from sleep

        WDTCTL = WDTPW + WDTHOLD;                               // Stop watchdog timer
        _BIS_SR(LPM4_bits + GIE);                               //SLEEP(); Enter LPM0 w/ interrupt

        _NOP();

        WDTCTL = WDTPW + WDTCNTCL;                              //Periodically clear an active watchdog

        //CalcChecksum((unsigned char *)ROM_START, ROM_END - ROM_START,(unsigned char *)&saved_CS);       //calc checksum

//~~~~ sw debaunce handler ~~~~~~
        delay(15000);                                           //a 75 Msec debaunce
        if(!(P1IN & ON_SW))
            {								
            delay(15000);
            if(!(P1IN & ON_SW))
                {
                if(! Batt_Check() )		                        //test for low batt on startup
                    stat=LOW_BATT;		                        //if low batt detaected change stat to low batt
                else
                    stat=RUN;                                   //else to run
                }
            }
        }
    }


void process_run()
    {  
    //*******************************************************************************
    for (E1_Failures_Counter = 0; E1_Failures_Counter < 8 ; E1_Failures_Counter++)
        E1_Failures[E1_Failures_Counter] = 0;
    
    E1_Failures_Counter = 0;
    //*******************************************************************************     
      
    P2OUT |= MAC_SW_PWR;	 		//mac sw power and green led
    P2OUT &= ~GREEN_LED;	 		//open green led
    P1OUT |= ORANGE_LED;                          //close orange led
    delay(1000);
    on_sw_cntr=0;	
    sw_was_presed=0;
//    mac_sw_stat=0
    run_time_cntr=0;
    mac_sw_press_timer=0;
    low_batt_flag=0;
    mac_sw_press_time_test_enable=0;              //clatc test active after firest sw relese
    mac_sw_stat = P2IN & MAC_SW;                  //lern the mac sw stat at start up
    mac_sw_was_presed=0;
    P1OUT |= MOTOR;				//open motor
    Check_Press_Overtime = 1;

    while(!(P1IN & ON_SW))                        //wait for ON_SW relese
        WDTCTL = WDTPW + WDTCNTCL;                //Periodically clear an active watchdog

    while(stat==RUN)
        {
        WDTCTL = WDTPW + WDTCNTCL;               //Periodically clear an active watchdog

        if(tick)                                 //if timer tick
            {
            tick=0;

//~~~~  mac sw debaunce and long cycle handler  ~~~~~~~~
            if(mac_sw_stat) //if MAC_SW is not presed
                {
                 if(!(P2IN & MAC_SW))			          //test if MAC_SW is presed for more then 200Ms
                    {                                                 //a litle debaunce
                    if(++i >= MAC_SW_DEBAUNCE)			  //ok MAC_SW is presed
                        {
                        //we discoverd the faling edge
                        mac_sw_stat=0;                    //set flag indicating MAC_SW is presed
                        mac_sw_was_presed=1;              //set flag indicating MAC_SW was presed
                        Check_Press_Overtime = 1;
                        E1_Failures[E1_Failures_Counter] = 0;

                        //~~~~test_for_low_batt_times~~~~
                        if((run_time_cntr >= LOW_BATT_TIME)&&(mac_sw_press_time_test_enable==1))//if interval is biger then 72 sec - low batt time
                          {  
                          //low_batt_flag=1;              //send sys to low batt imidiatly
                          E1_Failures[E1_Failures_Counter] = 1;
                          }

                        mac_sw_press_timer=0;
                        run_time_cntr=0;                  //reset counter
                        }
                    }
                 else
                    i=0;
                }
            else //if MAC_SW is presed
                 {
                 if(run_time_cntr >= MACHANICAL_FAILE_TIME_PRESURE)    //if sys is runing for more then 45 sec with straps in meaning machanical presure failore		
                    stat = LOW_BATT;                            //and stop

                 if((P2IN & MAC_SW))                      //look for MAC_SW relelise
                    {
                    //we discoverd the raizing edge
                    if(i-- <= 0)		                  //ok MAC_SW is relesed
                        {
                        mac_sw_stat=1;                    //set flag indicating MAC_SW is relised
                        stop_timer=0;
                        if(!mac_sw_press_time_test_enable)                  //if its the firest cycle
                            {
                            run_time_cntr=0;              //reset counter for firest step
                            mac_sw_press_time_test_enable=1;                //start to test the clatch
                            }
                        else
                            { 
                            if( mac_sw_press_timer < MIN_MAC_SW_PRESS_TIMER_INTERVAL)    //test for over flow meaning machanical failore
                                {
                                  E1_Failures[E1_Failures_Counter] = 1;
                                  //low_batt_flag=1;              //send sys to low batt imidiatly
                                }
                            
                          //Forwarding or Wrapping "E1_Failures_Counter"
                            if (E1_Failures_Counter < 7)
                               E1_Failures_Counter++;
                            else
                               E1_Failures_Counter = 0;                             
                            
                            }
                        }
                    }
                 else //MAC_SW is presed yet
                    {
                    i= MAC_SW_DEBAUNCE;

                    if(mac_sw_press_time_test_enable)                               //if the test is nenabled
                        {
                        mac_sw_press_timer++;                                       //increas the timer
                        if(mac_sw_press_timer > MAX_MAC_SW_PRESS_TIMER_INTERVAL)    //test for over flow meaning machanical failore
                            {
                            if (Check_Press_Overtime == 1)
                              {
                              E1_Failures[E1_Failures_Counter] = 1;
                              Check_Press_Overtime = 0;
                              mac_sw_press_timer = 0;
                              }
                            //low_batt_flag=1;              //send sys to low batt imidiatly
                            }
                        }
                    }
                 }
            
            if(mac_sw_press_time_test_enable)
            { 
              //Checking if there are 2 consequtive errors
              /*
              if (E1_Failures_Counter == 0)
                  if ((E1_Failures[0] == 1) && (E1_Failures[9] == 1))
                    low_batt_flag=1;
              else
                  if ((E1_Failures[E1_Failures_Counter] == 1) && (E1_Failures[E1_Failures_Counter - 1] == 1))
                    low_batt_flag=1;
              */
              
              //Checking if there are 2 total errors out of 10
              E1_Failures_Sum = 0;
              for (unsigned char j = 0 ; j < 8 ; j++)
                E1_Failures_Sum = E1_Failures_Sum + E1_Failures[j];
              
              if (E1_Failures_Sum >= 2)
                low_batt_flag=1;
            }

              
            

//~~~~  mac failore handler  ~~~~~~~~
            if(++run_time_cntr >= MACHANICAL_FAILE_TIME)    //if sys is runing for more then 110 sec	meaning machanical failore		
                stat = LOW_BATT;                            //and stop

//            if(run_time_cntr >= MACHANICAL_FAILE_TIME_PRESURE && !mac_sw_stat)    //if sys is runing for more then 45 sec with straps in meaning machanical presure failore		
//                stat = LOW_BATT;                            //and stop


//~~~~  low batt handler  ~~~~~~~~
            if( low_batt_flag )                                 //if low batt detected
                {
                if(stop_timer == MOTOR_STOP_POINT)              //look for stop point
                    stat = LOW_BATT;                            //and stop
                }


//~~~~  on sw handler  ~~~~~~~~
           if(!(P1IN & ON_SW))                                  //a 200 Ms debaunce for sw press
                {								
                if(on_sw_cntr++ > ON_SW_DEBAUNCE)
                    {
                    sw_was_presed=1;
                    //add for wdt test while(1)   P1OUT &= !ORANGE_LED;
                    }
                 }
            else
                on_sw_cntr=0;

            stop_timer++;
            if( sw_was_presed)
                {
                P2OUT ^= GREEN_LED;                             // Toggle green led
                if(stop_timer == MOTOR_STOP_POINT && mac_sw_was_presed )   //look for stop point after vlalied mac sw press
                    stat = SLEEP;                               //and stop
                }
            }
        }
    }
